Open In App

Count of subsequences with sum two less than the array sum

Last Updated : 12 Dec, 2021
Improve
Improve
Like Article
Like
Save
Share
Report

Given an array vec[] of size N of non-negative integers. The task is to count the number of subsequences with the sum equal to S – 2 where S is the sum of all the elements of the array.

Examples:

Input: vec[] = {2, 0, 1, 2, 1}, N=5
Output: 6
Explanation: {2, 0, 1, 1}, {2, 1, 1}, {2, 0, 2}, {2, 2}, {0, 1, 2, 1}, {1, 2, 1}

Input: vec[] = {2, 0, 2, 3, 1}, N=5
Output: 4
Explanation: {2, 0, 3, 1}, {2, 3, 1}, {0, 2, 3, 1}, {2, 3, 1}

Naive Approach: The idea is to generate all subsequences and check the sum of each and every individual subsequence equals S-2 or not. 

Below is the implementation of the above approach.

C++




// C++ program for the above approach
#include <bits/stdc++.h>
using namespace std;
 
// Function to count the total number
// of subsequences with sum S-2
void countTotal(vector<int>& vec)
{
 
    // Calculating vector sum using
    // accumulate function
    int sum = accumulate(vec.begin(),
                         vec.end(), 0LL);
 
    int N = (int)vec.size();
 
    // Answer variable stores count
    // of subsequences with desired sum
    int answer = 0;
 
    // Bitmasking technique to generate
    // all possible subsequences
    for (int mask = 0; mask < (1 << N); mask++) {
 
        // Variable curr counts the
        // sum of the current subsequence
        int curr = 0;
        for (int i = 0; i < N; i++) {
 
            if ((mask & (1 << i)) != 0) {
 
                // Include ith element
                // of the vector
                curr += vec[i];
            }
        }
 
        if (curr == sum - 2)
            answer++;
    }
 
    // Print the answer
    cout << answer;
}
 
// Driver Code
int main()
{
 
    // Initializing a vector
    vector<int> vec = { 2, 0, 1, 2, 1 };
 
    countTotal(vec);
 
    return 0;
}


Java




// Java program for the above approach
public class GFG {
     
    static int accumulate(int [] vec){
        int sum1 = 0;
         
        for (int i = 0; i < vec.length; i++)
            sum1 += vec[i];
    return sum1;
    }
     
    // Function to count the total number
    // of subsequences with sum S-2
    static void countTotal(int []vec)
    {
     
        // Calculating vector sum using
        // accumulate function
        int sum = accumulate(vec);
     
        int N = vec.length;
     
        // Answer variable stores count
        // of subsequences with desired sum
        int answer = 0;
     
        // Bitmasking technique to generate
        // all possible subsequences
        for (int mask = 0; mask < (1 << N); mask++) {
     
            // Variable curr counts the
            // sum of the current subsequence
            int curr = 0;
            for (int i = 0; i < N; i++) {
     
                if ((mask & (1 << i)) != 0) {
     
                    // Include ith element
                    // of the vector
                    curr += vec[i];
                }
            }
     
            if (curr == sum - 2)
                answer++;
        }
     
        // Print the answer
        System.out.print(answer);
    }
     
    // Driver Code
    public static void main (String[] args)
    {
     
        // Initializing a vector
        int []vec = { 2, 0, 1, 2, 1 };
     
        countTotal(vec);
    }
 
}
 
// This code is contributed by AnkThon


Python3




# python3 program for the above approach
 
# Function to count the total number
# of subsequences with sum S-2
def countTotal(vec) :
 
    # Calculating vector sum using
    # accumulate function
    Sum = sum(vec)
 
    N = len(vec);
 
    # Answer variable stores count
    # of subsequences with desired sum
    answer = 0;
 
    # Bitmasking technique to generate
    # all possible subsequences
    for mask in range((1 << N)) :
         
        # Variable curr counts the
        # sum of the current subsequence
        curr = 0;
        for i in range(N) :
 
            if ((mask & (1 << i)) != 0) :
 
                # Include ith element
                # of the vector
                curr += vec[i];
                 
        if (curr == Sum - 2) :
            answer += 1;
 
    # Print the answer
    print(answer);
 
# Driver Code
if __name__ == "__main__" :
 
 
    # Initializing a vector
    vec = [ 2, 0, 1, 2, 1 ];
 
    countTotal(vec);
 
    # This code is contributed by AnkThon


C#




// C# program for the above approach
using System;
 
public class GFG {
 
    static int accumulate(int[] vec)
    {
        int sum1 = 0;
 
        for (int i = 0; i < vec.Length; i++)
            sum1 += vec[i];
        return sum1;
    }
 
    // Function to count the total number
    // of subsequences with sum S-2
    static void countTotal(int[] vec)
    {
 
        // Calculating vector sum using
        // accumulate function
        int sum = accumulate(vec);
 
        int N = vec.Length;
 
        // Answer variable stores count
        // of subsequences with desired sum
        int answer = 0;
 
        // Bitmasking technique to generate
        // all possible subsequences
        for (int mask = 0; mask < (1 << N); mask++) {
 
            // Variable curr counts the
            // sum of the current subsequence
            int curr = 0;
            for (int i = 0; i < N; i++) {
 
                if ((mask & (1 << i)) != 0) {
 
                    // Include ith element
                    // of the vector
                    curr += vec[i];
                }
            }
 
            if (curr == sum - 2)
                answer++;
        }
 
        // Print the answer
        Console.WriteLine(answer);
    }
 
    // Driver Code
    public static void Main(string[] args)
    {
 
        // Initializing a vector
        int[] vec = { 2, 0, 1, 2, 1 };
 
        countTotal(vec);
    }
}
 
// This code is contributed by ukasp.


Javascript




<script>
// Javascript program for the above approach
 
// Function to count the total number
// of subsequences with sum S-2
function countTotal(vec) {
 
  // Calculating vector sum using
  // accumulate function
  let sum = vec.reduce((acc, curr) => acc + curr, 0)
 
  let N = vec.length;
 
  // Answer variable stores count
  // of subsequences with desired sum
  let answer = 0;
 
  // Bitmasking technique to generate
  // all possible subsequences
  for (let mask = 0; mask < (1 << N); mask++) {
 
    // Variable curr counts the
    // sum of the current subsequence
    let curr = 0;
    for (let i = 0; i < N; i++) {
 
      if ((mask & (1 << i)) != 0) {
 
        // Include ith element
        // of the vector
        curr += vec[i];
      }
    }
 
    if (curr == sum - 2)
      answer++;
  }
 
  // Print the answer
  document.write(answer);
}
 
// Driver Code
 
 
// Initializing a vector
let vec = [2, 0, 1, 2, 1];
 
countTotal(vec);
 
// This code is contributed by saurabh_jaiswal.
</script>


Output

6

Time Complexity: O(2N
Auxiliary Space: O(1)

Efficient Approach: The idea is to use the Combinatorics that apart from 0’s, 1’s, and 2’s, all the other elements in our array will be part of the desired subsequences. Let’s call them extra elements. Then, count the occurrences of 0’s, 1’s, and 2’s in the array. Let’s say the count of 0’s is x, count of 1’s be y, count of 2’s be z

  • Let’s count the number of desired subsequences if all 2’s and extra elements are in the subsequence. Now there can be exactly y – 2 elements out of y. Note that there is no restriction for taking 0’s as it contributes nothing to our subsequence sum.
  • Hence, the total count of such subsequences = count1 = 2x × yCy – 2  = 2x × yC2 ( Since, nC0 + nC1 + . . . + nCn  = 2n).
  • Let’s count the number of subsequences if all the 1’s are in our subsequence. Now there can be exactly z – 1 elements out of z.
  • Hence, the total count of such subsequences = count2 = 2 × zCz – 1 = 2x  Ã—   zC1
  • Total count of subsequences whose sum is equal to S – 2, count = count1 + count2 = 2x × ( yC2 + zC1 )

Follow the steps below to solve the problem:

  • Initialize the variable sum as the sum of the array.
  • Initialize the variable answer as 0 to store the answer.
  • Initialize the variables countOfZero, countOfOne and countOfTwo to store the count of 0, 1 and 2.
  • Traverse the array vec[] using the iterator x and perform the following tasks:
    • Count the occurrences of 0’s, 1’s, and 2’s.
  • Initialize the variables value1 as 2countOfZero.
  • Initialize the variable value2 as (countOfOne * (countOfOne – 1)) / 2.
  • Initialize the variable value3 as countOfTwo.
  • Set the value of answer as value1 * ( value2 + value).
  • After performing the above steps, print the value of answer as the answer.

Below is the implementation of the above approach.

C++




// C++ program for the above approach
#include <bits/stdc++.h>
using namespace std;
 
// Function to count the total number
// of subsequences with sum S-2
void countTotal(vector<int>& vec)
{
 
    // Calculating vector sum using
    // accumulate function
    int sum = accumulate(vec.begin(),
                         vec.end(), 0LL);
 
    int N = (int)vec.size();
 
    // Answer variable stores count
    // of subsequences with desired sum
    int answer = 0;
 
    int countOfZero = 0,
        countOfOne = 0,
        countOfTwo = 0;
    for (auto x : vec) {
        if (x == 0)
            countOfZero++;
        else if (x == 1)
            countOfOne++;
        else if (x == 2)
            countOfTwo++;
    }
 
    // Select any number of
    // zeroes from 0 to count[0]
    // which is equivalent
    // to 2 ^ countOfZero
    int value1 = pow(2, countOfZero);
 
    // Considering all 2's
    // and extra elements
    int value2
        = (countOfOne
           * (countOfOne - 1))
          / 2;
 
    // Considering all 1's
    // and extra elements
    int value3 = countOfTwo;
 
    // Calculating final answer
    answer = value1 * (value2 + value3);
 
    // Print the answer
    cout << answer;
}
 
// Driver Code
int main()
{
 
    // Initializing a vector
    vector<int> vec = { 2, 0, 1, 2, 1 };
 
    countTotal(vec);
 
    return 0;
}


Java




/*package whatever //do not write package name here */
import java.io.*;
 
class GFG {
    // Function to count the total number
    // of subsequences with sum S-2
    static void countTotal(int[] arr)
    {
 
        int N = arr.length;
 
        // Answer variable stores count
        // of subsequences with desired sum
        int answer = 0;
 
        int countOfZero = 0, countOfOne = 0, countOfTwo = 0;
        for (int i = 0; i < N; i++) {
 
            if (arr[i] == 0)
                countOfZero++;
            else if (arr[i] == 1)
                countOfOne++;
            else if (arr[i] == 2)
                countOfTwo++;
        }
 
        // Select any number of
        // zeroes from 0 to count[0]
        // which is equivalent
        // to 2 ^ countOfZero
        int value1 = (1 << countOfZero);
 
        // Considering all 2's
        // and extra elements
        int value2 = (countOfOne * (countOfOne - 1)) / 2;
 
        // Considering all 1's
        // and extra elements
        int value3 = countOfTwo;
 
        // Calculating final answer
        answer = value1 * (value2 + value3);
 
        // Print the answer
        System.out.println(answer);
    }
 
    // Driver Code
    public static void main(String[] args)
    {
        // Initializing an array
        int[] arr = { 2, 0, 1, 2, 1 };
 
        countTotal(arr);
    }
}
 
// This code is contributed by maddler.


Python3




# Python3 program for the above approach
 
# Function to count the total number
# of subsequences with sum S-2
def countTotal(vec) :
 
    # Calculating vector sum using
    # accumulate function
    sum1 = sum(vec);
 
    N = len(vec);
 
    # Answer variable stores count
    # of subsequences with desired sum
    answer = 0;
    countOfZero = 0; countOfOne = 0; countOfTwo = 0;
    for x in vec :
         
        if (x == 0) :
            countOfZero += 1;
             
        elif (x == 1) :
            countOfOne += 1;
             
        elif (x == 2) :
            countOfTwo += 1;
 
    # Select any number of
    # zeroes from 0 to count[0]
    # which is equivalent
    # to 2 ^ countOfZero
    value1 = 2 ** countOfZero;
 
    # Considering all 2's
    # and extra elements
    value2 = (countOfOne * (countOfOne - 1)) // 2;
 
    # Considering all 1's
    # and extra elements
    value3 = countOfTwo;
 
    # Calculating final answer
    answer = value1 * (value2 + value3);
 
    # Print the answer
    print(answer);
 
# Driver Code
if __name__ == "__main__" :
 
    # Initializing a vector
    vec = [ 2, 0, 1, 2, 1 ];
    countTotal(vec);
     
    # This code is contributed by AnkThon


C#




// Above approach implemented in C#
using System;
 
public class GFG {
     
    // Function to count the total number
    // of subsequences with sum S-2
    static void countTotal(int[] arr)
    {
 
        int N = arr.Length;
 
        // Answer variable stores count
        // of subsequences with desired sum
        int answer = 0;
 
        int countOfZero = 0, countOfOne = 0, countOfTwo = 0;
        for (int i = 0; i < N; i++) {
 
            if (arr[i] == 0)
                countOfZero++;
                 
            else if (arr[i] == 1)
                countOfOne++;
                 
            else if (arr[i] == 2)
                countOfTwo++;
        }
 
        // Select any number of
        // zeroes from 0 to count[0]
        // which is equivalent
        // to 2 ^ countOfZero
        int value1 = (1 << countOfZero);
 
        // Considering all 2's
        // and extra elements
        int value2 = (countOfOne * (countOfOne - 1)) / 2;
 
        // Considering all 1's
        // and extra elements
        int value3 = countOfTwo;
 
        // Calculating final answer
        answer = value1 * (value2 + value3);
 
        // Print the answer
        Console.WriteLine(answer);
    }
 
    // Driver Code
    public static void Main(string[] args)
    {
       
        // Initializing an array
        int[] arr = { 2, 0, 1, 2, 1 };
 
        countTotal(arr);
    }
}
 
// This code is contributed by AnkThon


Javascript




<script>
 
       // JavaScript Program to implement
       // the above approach
 
       // Function to count the total number
       // of subsequences with sum S-2
       function countTotal(vec)
       {
 
           // Calculating vector sum using
           // accumulate function
           let sum = vec.reduce(function (accumulator, currentValue) {
               return accumulator + currentValue;
           }, 0);
 
           let N = vec.length;
 
           // Answer variable stores count
           // of subsequences with desired sum
           let answer = 0;
 
           let countOfZero = 0,
               countOfOne = 0,
               countOfTwo = 0;
           for (let x of vec) {
               if (x == 0)
                   countOfZero++;
               else if (x == 1)
                   countOfOne++;
               else if (x == 2)
                   countOfTwo++;
           }
 
           // Select any number of
           // zeroes from 0 to count[0]
           // which is equivalent
           // to 2 ^ countOfZero
           let value1 = Math.pow(2, countOfZero);
 
           // Considering all 2's
           // and extra elements
           let value2
               = (countOfOne
                   * (countOfOne - 1))
               / 2;
 
           // Considering all 1's
           // and extra elements
           let value3 = countOfTwo;
 
           // Calculating final answer
           answer = value1 * (value2 + value3);
 
           // Print the answer
           document.write(answer);
       }
 
       // Driver Code
       // Initializing a vector
       let vec = [2, 0, 1, 2, 1];
 
       countTotal(vec);
 
   // This code is contributed by Potta Lokesh
   </script>


Output

6

Time Complexity: O(N) 
Auxiliary Space: O(1)



Like Article
Suggest improvement
Previous
Next
Share your thoughts in the comments

Similar Reads